#include "stdafx.h"
#include "MainWindow.h"

namespace TestWindowsMediaTIFF {

MainWindow::MainWindow(void)
{
	this->InitializeComponent();
  if (this->DesignMode) return;
}
//end MainWindow::MainWindow()

System::Void MainWindow::OnClickEvent(System::Object^ sender, System::EventArgs^ args)
{
  if (sender == this->button1)
  {
    try{
      bool result = false;
      System::String^ inputFile = "im32f.tiff";
      System::String^ outputFile = "im32f_out.tiff";
      System::IO::File::Copy(inputFile, outputFile, true);
      System::IO::MemoryStream^ tmpStream = nullptr;
      System::IO::FileStream^ imageStream = !outputFile ? nullptr :
        gcnew System::IO::FileStream(outputFile, System::IO::FileMode::Open, System::IO::FileAccess::ReadWrite, System::IO::FileShare::ReadWrite);
      System::Windows::Media::Imaging::BitmapDecoder^ bitmapDecoder = !imageStream ? nullptr : 
        System::Windows::Media::Imaging::BitmapDecoder::Create(imageStream, System::Windows::Media::Imaging::BitmapCreateOptions::PreservePixelFormat | System::Windows::Media::Imaging::BitmapCreateOptions::IgnoreColorProfile, System::Windows::Media::Imaging::BitmapCacheOption::Default);
      System::Collections::ObjectModel::ReadOnlyCollection<System::Windows::Media::Imaging::BitmapFrame^>^ bitmapFrames = !bitmapDecoder ? nullptr : bitmapDecoder->Frames;
      System::Windows::Media::Imaging::BitmapFrame^ bitmapFrame = !bitmapFrames || !bitmapFrames->Count ? nullptr : bitmapFrames[0];
      System::Console::WriteLine("decoded bitmapFrame->Format = {0}", !bitmapFrame ? nullptr : bitmapFrame->Format.ToString());
      
      System::Windows::Media::Imaging::BitmapEncoder^ bitmapEncoder = gcnew System::Windows::Media::Imaging::TiffBitmapEncoder();

      System::Windows::Media::Imaging::BitmapFrame^ dstBitmapFrame = bitmapFrame;

      const bool writeMetaData = false;
      System::Windows::Media::Imaging::InPlaceBitmapMetadataWriter^ mdWriter = !writeMetaData || !bitmapFrame ? nullptr : bitmapFrame->CreateInPlaceBitmapMetadataWriter();
      if (mdWriter)
      {
        System::Windows::Media::Imaging::BitmapMetadata^ bitmapMetaDataSrc =
          !bitmapFrame ? nullptr : dynamic_cast<System::Windows::Media::Imaging::BitmapMetadata^>(bitmapFrame->Metadata);
        System::Windows::Media::Imaging::BitmapMetadata^ bitmapMetaDataDst =
          (bitmapMetaDataSrc != nullptr) ? dynamic_cast<System::Windows::Media::Imaging::BitmapMetadata^>(bitmapMetaDataSrc->Clone()) :
          nullptr;
        if (bitmapMetaDataDst)
        {
          unsigned int paddingAmount = 1U*2048;
          bitmapMetaDataDst->SetQuery("/app1/ifd/PaddingSchema:Padding", paddingAmount);
          bitmapMetaDataDst->SetQuery("/app1/ifd/exif/PaddingSchema:Padding", paddingAmount);
          bitmapMetaDataDst->SetQuery("/xmp/PaddingSchema:Padding", paddingAmount);
          bitmapMetaDataDst->ApplicationName = "ApplicationName";
          dstBitmapFrame = System::Windows::Media::Imaging::BitmapFrame::Create(bitmapFrame, bitmapFrame->Thumbnail, bitmapMetaDataDst, bitmapFrame->ColorContexts);
        }//end if (bitmapMetaDataDst)
      }//end if (mdWriter)

      bitmapEncoder->Frames->Add(dstBitmapFrame);
      System::Windows::Media::Imaging::TiffBitmapEncoder^ tiffBitmapEncoder = dynamic_cast<System::Windows::Media::Imaging::TiffBitmapEncoder^>(bitmapEncoder);
      if (tiffBitmapEncoder != nullptr)
      {
        System::Windows::Media::Imaging::TiffCompressOption compression = System::Windows::Media::Imaging::TiffCompressOption::None;
        tiffBitmapEncoder->Compression = compression;
      }//end if (tiffBitmapEncoder != nullptr)
      tmpStream = gcnew System::IO::MemoryStream(static_cast<int>(imageStream->Length));
      if (tmpStream)
      {
        if (dstBitmapFrame->Palette)
          bitmapEncoder->Palette = dstBitmapFrame->Palette;
        bitmapEncoder->Save(tmpStream);
      }//end if (tmpStream)

      delete mdWriter;
      delete bitmapEncoder;
      delete bitmapDecoder;
      delete imageStream;
      if (!result && tmpStream)
      {
        System::IO::File::WriteAllBytes(outputFile, tmpStream->ToArray());
        result = true;
      }//end if (!result && tmpStream)
      delete tmpStream;

      imageStream = !outputFile ? nullptr :
        gcnew System::IO::FileStream(outputFile, System::IO::FileMode::Open, System::IO::FileAccess::Read, System::IO::FileShare::Read);
      bitmapDecoder = !imageStream ? nullptr : 
        System::Windows::Media::Imaging::BitmapDecoder::Create(imageStream, System::Windows::Media::Imaging::BitmapCreateOptions::PreservePixelFormat | System::Windows::Media::Imaging::BitmapCreateOptions::IgnoreColorProfile, System::Windows::Media::Imaging::BitmapCacheOption::Default);
      bitmapFrames = !bitmapDecoder ? nullptr : bitmapDecoder->Frames;
      bitmapFrame = !bitmapFrames || !bitmapFrames->Count ? nullptr : bitmapFrames[0];
      System::Console::WriteLine("reencoded bitmapFrame->Format = {0}", !bitmapFrame ? nullptr : bitmapFrame->Format.ToString());

      delete bitmapDecoder;
      delete imageStream;
    }
    catch(System::Exception^ e){
      System::Console::WriteLine("e = {0}", e);
    }

  }//end if (sender == this->button1)
}
//end MainWindow::OnClickEvent()

}//end namespace TestWindowsMediaTIFF
